/* header */
%{

let rec sum l = match l with
  [] -> 0
| hd::tl -> hd + sum tl


let rec mult l = match l with
  [] -> 1
| hd::tl -> hd * mult tl


%}

/* declarations */
%token <int> INT
%token PLUS TIMES
%token LPAREN RPAREN
%token EOL
%left PLUS
%left TIMES

%start main
%type <int> main


/* rules */
%%

main:
	expr EOL			{ $1 }
;

expr:
	  INT				{ $1 }
	| LPAREN PLUS elist		{ sum $3 }
	| LPAREN TIMES elist		{ mult $3 }
;

elist:
	  expr elist			{ $1::$2 }
	| RPAREN			{ [] }
;
